#!/usr/bin/perl

use lib "./modules";

use Getopt::Std;
use arb_scan;


getopts('hrl:s:i:t:c:', \%opt) || usage();

# Parse options
if (defined($opt{'h'})) {
  usage();
  exit(0);
}
if (defined($opt{'c'})) {
  do "$opt{'c'}" || die print "Error: Can't read config file($opt{'c'}) because: $!\n";
}
else {
  do "./config/arb-scan.conf" || die print "Error: Can't read config file(./config/arb-scan.conf) because : $!\n";
}
if (defined($opt{'t'})) {
  if ($opt{'t'} !~ /daytime|ftp|ssh|smtp|domain|finger|http|pop2|pop3|imap|none|all/i) {
    usage();
    exit(1);
  }
  else {
    $service = $opt{'t'};
  }
}
else {
   usage();
   exit(1);
}
if (defined($opt{'s'})) {
  $dest = $opt{'s'};
}
elsif (defined($opt{'r'})) {
  if (defined($opt{'l'})) {
    if (!($opt{'l'} <= 0)) {
      $loop_count = $opt{'l'};
    }
    else {
      usage();
      exit(1);
    }
  }
  else {
    $loop_count = 1;
    $dest = rand_ip();
  }
}
elsif (defined($opt{'i'})) {
  $file = $opt{'i'};
}
else {
  usage();
  exit(1);
}

if ($SHOWVERSION == 1) {
  header();
}

if (defined($file)) {
  open(*fileh, $file) || die print "Error: Can't open ip-file($file) because: $!\n";  
  @hosts = <fileh>;
  close(*fileh);

  print "- found ", $#hosts+1, " hosts in $file\n";
  foreach $dest (@hosts) {
    chomp($dest);
    if ($COUNT == 1) {
      $i++;
      print "- next host is number : $i\n";
    }
    select_service($dest, $service);
    if ($SHOWOS == 1) {
      show_os($dest);
    }
    print
  }  
} 
elsif (defined($loop_count)) {
  for ($i = 1; $i <= $loop_count; $i++) {
    $dest = rand_ip();
    if ($COUNT == 1) {
      print "- next host is number : $i\n";
    }   
    select_service($dest, $service);
    if ($SHOWOS == 1) {
      show_os($dest);
    }
  }
}
else {
  select_service($dest, $service);
  if ($SHOWOS == 1) {
    show_os($dest);
  }
}

# by arbon(arbon@gmx.de)
